% Run a whole bunch of CA stuff

% ========================================================================
% ========================================================================

% pipeline features
nAlgs = 1;
doVariableImportance = false;
doQuadratic = false;
cappedIncluded = true;
doPortfolio=false;
global doSubplots; doSubplots = false;
doBackTransform = false;
global useValidSet; useValidSet = false;
global saveFigs; saveFigs = true;
global delta;  delta = 1e-6;

%Data massaging parameters
linearR2Cutoff = 0.9999999; 
quadR2Cutoff = 0.99999;
doLinearPreprocessing = true;
doQuadPreprocessing = true;

% response variable transformations
global modelTransformations; modelTransformations = {'identity'; 'logistic'; 'log'; 'cuberoot'};
global transformation;  transformation = 3;  % this is one of the entries in the list one line above this line

% subset selection parameters
linSize = 30;
quadSize = 4000;
subsetSelectionMethods = {'forwardSelection'; 'backwardsSelection'; 'sequentialReplacement'; 'all'; 'exhaustive'};
linearSelectionMethod = 4;  % this is one of the entries in the list one line above this line
quadraticSelectionMethod = 1;
variableImportanceSelectionMethod = 4;

% variable importance parameters
variableImportanceSubsetSize = 0;  % if set to zero, variable importance uses smallest subset within 10% RMSE of full model
variableSelectionMaxSubsetSize = 80;
necessary_feature_threshold = .95;
vImpThreshold = 5.5; %0.1

%randomization test amount
randomAmt = 0.1;

% Parameters relating to input files
% ------------------------------------------------------------------------

location='./cadata/';

%currDataFile = 'ca-1k-256-cplex';
%currDataFile = 'ca-1k-144-cplex';
%currDataFile = 'ca-2k-64-cplex';
%currDataFile = 'ca-varsize-cplex';
%currDataFile = 'ca-1k-256-3solvers'; nAlgs = 3; doPortfolio=true; 
%currDataFile = 'ca-varsize-2solvers'; nAlgs = 2; doPortfolio=true;

%First do linear runs, no vimp
doQuadratic = false;

currDataFile = 'ca-1k-256-cplex';
pipeline_exec

currDataFile = 'ca-varsize-cplex';
pipeline_exec

currDataFile = 'ca-1k-144-cplex';
pipeline_exec

currDataFile = 'ca-2k-64-cplex';
pipeline_exec

%Then Quadratic, no vimp yet
doQuadratic = true;

currDataFile = 'ca-1k-256-cplex';
pipeline_exec

currDataFile = 'ca-varsize-cplex';
pipeline_exec

currDataFile = 'ca-1k-144-cplex';
pipeline_exec

currDataFile = 'ca-2k-64-cplex';
pipeline_exec

%Then do Portfolio stuff
currDataFile = 'ca-1k-256-3solvers'; nAlgs = 3; doPortfolio=true; 
pipeline_exec

currDataFile = 'ca-varsize-2solvers'; nAlgs = 2; doPortfolio=true;
pipeline_exec

disp('Remember to do VIMP for linear and quadratic stuff!');

