% function [model A Ainv XtY] = modelRemoveFeature(X, k, y, A, Ainv, delta, XtY)
% Train the linear model (X'X + I \delta)^{-1}X'y, given the matrix product
% and inverse from the previous iteration
function [model,A,Ainv,XtY] = modelRemoveFeature(X, k, y, A, Ainv, delta, XtY)
	p = size(A,1);

	% swap rows and columns so that the row/column to be deleted is the last one
	temp = A(:,k);
	A(:,k:end-1) = A(:,k+1:end);
	A(:,end) = temp;
	temp = A(k,:);
	A(k:end-1,:) = A(k+1:end,:);
	A(end,:) = temp;
	
	% likewise, swap rows and columns in Ainv so that it is now the inverse
	% of the newly swapped version of A
	temp = Ainv(:,k);
	Ainv(:,k:end-1) = Ainv(:,k+1:end);
	Ainv(:,end) = temp;
	temp = Ainv(k,:);
	Ainv(k:end-1,:) = Ainv(k+1:end,:);
	Ainv(end,:) = temp;

	aBar = A(p,1:p-1); % row
	aDot = A(p,p);
	
    %!!!!!!!!!!!!NOTE
    %!!!!!!!!!!!! This needs to be fixed. get division by zero sometimes.
    %!!!!!!!!!!!! Possibly increase delta and restart....
    
	% first rank one update
	u1 = [-aBar'; -aDot+1];
	v1 = [zeros(p-1,1); 1];
    denom = (1 + v1'*Ainv*u1);
    if denom == 0
        % About to divide by 0!
		model = -1;
	else
		Ainv = Ainv - ((Ainv*u1)*(v1'*Ainv))/ denom;
	%	tmp = Ainv(:,p);
	%	tmp2 = Ainv(p,:);
	%	tmp(p) = tmp(p)-1;
	%	Ainv = Ainv - (tmp*tmp2)/(1 + tmp2*u1);

		% second rank one update
		%u2 = v1;
		v2 = [-aBar'; 0];
		%Attinv = Atinv - ((Atinv*u2)*(v2'*Atinv))/(1 + v2'*Atinv*u2);
		denom = (1 + v2'*Ainv(:,p));
		if (denom == 0)
		    % About to divide by 0!
			model = -1;
		else
			Ainv = Ainv - (Ainv(:,p)*(v2'*Ainv))/denom;
			Ainv = Ainv(1:p-1,1:p-1);

			% build the model
			XtY = XtY(1:p~=k,:);
			model = Ainv * XtY;
			A=A(1:end-1,1:end-1);
		end
	end
end	
	