function [df res]=preprocessSaveFeatures(origdf, cutoff, outputFileName)
%function [df res]=preprocessSaveFeatures(df, cutoff, [outputFileName])
%
%Iteratively try to predict each feature with the rest, and remove it if prediction is
%too good

error(nargchk(2,3,nargin));

df=origdf;
res=[];

tic

iter=1;

display('Preprocessing useless features...');

%[model preds condNumber] = trainModel(df, true, false);
%res(iter).condNumber = condNumber;

done = false;

allfeats=1:size(df.traindata.features,2);       
    
badfeature=allfeats;
while size(badfeature,2)>0

    display(sprintf('Starting iteration: %d, with %d bad features\n',iter, size(badfeature,2)));
    allfeats=1:size(df.traindata.features,2);  
    removelist=[];
    %consider all features
    for f=badfeature
        
        %replace response and predict
        df.traindata.response=df.traindata.features(:,f);
        tmpDf = projectDF(df, allfeats~=f);
        stats=modelStats(tmpDf, true, false);
        res(iter).R2(f)=stats.r2;
        if stats.r2< cutoff
            removelist=[removelist, f];
        end
        
        %resR2(iter,f)=stats.adjR2;       
    end
    
    %find feature to be removed
    [r2 idx]=max(res(iter).R2);
    res(iter).toRemove=idx;
    res(iter).name=df.featurenames{idx};
  
    if r2 < cutoff
        fprintf('This feature is  OK!\n');
        break;
    end
    
%    display(sprintf('Removing feature: %s with r2 %f and cond %e\n', df.featurenames{idx}, r2, condNumber)); 
    display(sprintf('Removing feature: %s with r2 %f\n', df.featurenames{idx}, r2)); 
    df=projectDF(df, allfeats~=idx);
    for j =removelist
    badfeature=badfeature(badfeature~=j);
    end
     badfeature=badfeature(badfeature~=idx);
    badfeature(find(badfeature>idx))=badfeature(find(badfeature>idx))-1;
    
    
    %%some bad feature becomes good
    
    
    iter=iter+1;
%    [model preds condNumber] = trainModel(df, true, false);
%    res(iter).condNumber = condNumber;
end

df.traindata.response = origdf.traindata.response;

display('Preprocessing finished!');
toc

%save file
if nargin == 3
    save(outputFileName, 'res');
end

