function [preds,model,condNumber]= trainModel(df, useValidSet,doBackTransform)
%function [preds model condNumber] = trainModel(df, useValidSet, doBackTransform)
%
%Train regression model and return coefficients

error(nargchk(3,3,nargin));
global delta;
TrainM = [df.traindata.features ones(size(df.traindata.features,1),1)];

% deal with rank deficiency, approximates using pseudo-inverse
A = TrainM' * TrainM + delta * eye(size(TrainM,2));
condNumber=klbcond(A);

model = inv(A) * (TrainM' * df.traindata.response);

if useValidSet
    preds = [df.validdata.features ones(size(df.validdata.features,1),1)] * model;
else
    preds = [df.testdata.features ones(size(df.testdata.features,1),1)] * model;
end


if (doBackTransform)
	preds = feval(df.backtransform, preds, df);
end



