function dataframe = transformData(df, transform)
%df = transformData(df, transform)
%
%transform a data frame, and set up function pointer to point back
%valid values for transform are 'identity', 'log', 'logistic'

switch transform
    case 'identity'
		df.backtransform = @IDTransform;        
        dataframe = df;
    case 'log'
        dataframe = LogTransform(df);    
    case 'logistic'
        dataframe = LogisticTransform(df);
    case 'cuberoot'
        dataframe = CubeRootTransform(df);
    otherwise
        error(['Invalid transform name: ' transform]);
end

