%Output subsets into a file
function writeSubsetFile(subsetPrefix, subs, df)

filename = [subsetPrefix '-' df.algname '.csv'];
fid = fopen(filename,'wb');
if fid == (-1), error(['Could not open file ' filename]); end

n=length(subs);
fprintf(fid, 'Size,TrainRMSE,TrainMAE\n');
for i=1:n
    fprintf(fid, '%d,%15.10f,%15.10f\n', i, subs(i).RMSE, subs(i).MAE);
end

fprintf(fid, '\n\nSubsets\n\n');

for i=1:n
    fprintf(fid, '%d\n', i);
    feats=df.featurenames(subs(i).features);
    for j=1:i
        fprintf(fid, '%s\n', char(feats(j)));
    end
end

fclose(fid);

%--------------------------------------------------------------------------
